var Bco54200_ExtratoBancario_Service = function(Bco54200_ExtratoBancario_Repository){
    /*********************************Extrato Bancário***************************************/

    /**
     * Essa função tem como finalidade montar o filtro que sera passado para a função
     * que ira gerar o report.
     *
     * @param  {Object} row current row da widget
     */
    this.geraReport = function(row) {
        var filtro = {
            TDATA : row.DTINICIAL ? null : 'T',
            DTINICIAL : row.DTINICIAL || null,
            DTFINAL : row.DTFINAL || null,
            TCDREDUCONT : row.CDREDUCONT ? null : 'T',
            CDREDUCONT : row.CDREDUCONT || null,
            __report_name : row.REPORT_NAME || 'BCO54200'
        };
        return Bco54200_ExtratoBancario_Repository.geraReport(filtro);
    };

    /***************************Importação de Extrato Bancário*******************************/

    /**
     * Essa função tem como finalidade receber o conteudo do arquivo lido e dividilo onde ele de fato começa e do que
     * host local. Montar uma row que sera passado ao backend com pela classe Bco54200_ExtratoBancario_Repository com
     * a função uploadFile.
     *
     * @param  {String} contentFile conteudo do arquivo, em base 64
     * @param  {String} banco       CDBANCCNAB do banco do aquivo, caso o arquvio seja TXT
     * @param  {String} tipo        tipo do arquivo (TXT ou OFX)
     */
    this.uploadContentFile = function(contentFile, banco, tipo) {
        var contentFilSplit = contentFile.split(',');
        var contentFileFormat = contentFilSplit[1];
        var row = { CONTEUDO : contentFileFormat,
                    TIPO     : tipo,
                    BANCO    : banco};
        return Bco54200_ExtratoBancario_Repository.uploadFile(row);
    };

    /**
     * Essa função tem como finalidade retirar do arrauy data as linhas que tem a propriedade
     * SAVE igual a N, pois essa linhas não pode ser salvar. Depois chamar o repository que
     * ira salvar os dados que foram lidos do arquivo de extrato bancario a ser importado.
     *
     * @param  {Array} data registros lidos do arquivo
     * @return {Object}      promisse do restEngine
     */
    this.saveImport = function(data) {
        for (var i = data.length - 1; i >= 0; i--) {
            if (data[i].SAVE === 'N') {
                data.splice(i, 1);
            }
        }
        return Bco54200_ExtratoBancario_Repository.saveImport(data);
    };
};
Configuration(function (ContextRegister){
    ContextRegister.register('Bco54200_ExtratoBancario_Service', Bco54200_ExtratoBancario_Service);
});